# tree-sitter-srpm-macros

RPM macros for Tree-sitter parsers.

## Build system declaration

Put `BuildSystem: tree_sitter` in the preamble, in place of manually providing `%prep`, `%conf`, `%generate_buildrequires`, `%build`, `%install` and `%check` sections.

## `tree_sitter` macro

Automatically declare subpackages with the `tree_sitter` macro:

```
%{tree_sitter -l human-friendly-language-name [-P] [-R]}
```

### Python and Rust subpackages

> [!WARNING]
> This feature is experimental.

You can build subpackages for Python or Rust bindings by passing `--with=python` or `--with=rust` respectively to `rpmbuild`.  Alternatively, you can pass the `-P` or `-R` options to the `tree_sitter` macro, which will do the same thing.

## Example `.spec`

```specfile
Name:           tree-sitter-c
Version:        0.21.4
Release:        %autorelease
License:        MIT
URL:            https://github.com/tree-sitter/%{name}
Source:         %{url}/archive/v%{version}/%{name}-%{version}.tar.gz
BuildSystem:    tree_sitter


%{tree_sitter -l %{quote:C and C++}}


%changelog
%autochangelog
```
